Subject: Re: [Patch v4 03/12] net: mana: Handle vport sharing between devices

From: Jason Gunthorpe <[email-masked]>
Date: Thu, 21 Jul 2022 15:32:19 -0300

On Thu, Jul 21, 2022 at 05:58:39PM +0000, Long Li wrote:
> > > "vport" is a hardware resource that can either be used by an Ethernet
> > > device, or an RDMA device. But it can't be used by both at the same
> > > time. The "vport" is associated with a protection domain and doorbell,
> > > it's programmed in the hardware. Outgoing traffic is enforced on this
> > > vport based on how it is programmed.
> > 
> > Sure, but how is the users problem to "get this configured right" and what
> > exactly is the user supposed to do?
> > 
> > I would expect the allocation of HW resources to be completely transparent
> > to the user. Why is it not?
> > 
> 
> In the hardware, RDMA RAW_QP shares the same hardware resource (in
> this case, the vPort in hardware table) with the ethernet NIC. When
> an RDMA user creates a RAW_QP, we can't just shut down the
> ethernet. The user is required to make sure the ethernet is not in
> used when he creates this QP type.

You haven't answered my question - how is the user supposed to achieve
this?

And now I also want to know why the ethernet device and rdma device
can even be loaded together if they cannot share the physical port?
Exclusivity is not a sharing model that any driver today implements.

Jason